#ifndef FILTERTABLEVIEW_H
#define FILTERTABLEVIEW_H

#include <QTableView>
#include <QTimer>
#include <QLineEdit>
#include <QHBoxLayout>
#include <QHeaderView>
#include <QRegExpValidator>
#include <QAbstractItemModel>
#include <QSortFilterProxyModel>


class FilterTableView : public QTableView
{
    Q_OBJECT
public:
    explicit FilterTableView(QWidget *parent = nullptr);

    void setRegExpForColumn(QMap<int, QString> regexpColumns);
    void setEditColumns(QVector<int> editColumns);

    void setModel(QAbstractItemModel *model) Q_DECL_OVERRIDE;

private:
    void setFilter(const QString text, const int column);
    QWidget *createLineEditForColumn(const int column);
    void filterLayoutAddWidgets();


    QHBoxLayout *_filterLayout;
    QAbstractItemModel *_model;
    QMap<int, QString> _regexpColumns;
    QVector<int> _editColumns;
    QTimer *_timer;
signals:
    void filterTViewTextChanged(const int column, const QString text);
};

#endif // FILTERTABLEVIEW_H
