#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
    , ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    _tv = new FilterTableView();

    _proxy = new QSortFilterProxyModel;
    _model = new QStandardItemModel(_tv);
    _model->setHorizontalHeaderLabels(QStringList() << "Column 1" << "Column 2" << "Column 3");
    for (int i = 0; i < 4; ++i) {
        QList<QStandardItem *> items;
        items.append(new QStandardItem(QString("Row %1").arg(i)));  // Первая колонка
        items.append(new QStandardItem("Item 2"));                  // Вторая колонка
        items.append(new QStandardItem("Item 3"));                  // Третья колонка
        _model->appendRow(items);
    }
    _proxy->setSourceModel(_model);
    _tv->setModel(_proxy);
    ui->verticalLayout->addWidget(_tv);

    connect(_tv, &FilterTableView::filterTViewTextChanged, [this](const int column, const QString text){
        setFilter(column, text);
    });
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::setFilter(const int column, const QString pattern)
{
    _proxy->setFilterKeyColumn(column);
    _proxy->setFilterCaseSensitivity(Qt::CaseInsensitive);
    _proxy->setFilterFixedString(pattern);
}

